
//JQuery代码
//读取excel表中数据
//
var excelDataArray = []; //通用导入内容
var wb;//读取完成的数据
var rABS = false; //是否将文件读取为二进制字符串

// const IMPORTFILE_MAXSIZE = 10*1024;//这里可以自定义控制导入文件大小
function parseXlsx(obj, callback) {//导入
    if (typeof callback != 'function'){
        alert("回调格式异常");
        return;
    }
     if(obj.files.length==0) {
         callback(excelDataArray)
         return;
    }
    var suffix = obj.files[0].name.split(".")[1]
    if(suffix != 'xls' && suffix !='xlsx'){
        alert("文件格式异常!");
        $(obj).val('');
        return;
    }
    // if(obj.files[0].size/1024 > IMPORTFILE_MAXSIZE){
    //     alert("The file can not over 10MB");
    //     return;
    // }
    var f = obj.files[0];
    var reader = new FileReader();
    reader.onload = function(e) {
        console.log(typeof callback)
        excelDataArray = e.target.result;
        if(rABS) {
            wb = XLSX.read(btoa(fixdata(excelDataArray)), {//手动转化
                type: 'base64'
            });
        } else {
            wb = XLSX.read(excelDataArray, {
                type: 'binary'
            });
        }
        //wb.SheetNames[0]是获取Sheets中第一个Sheet的名字
        //wb.Sheets[Sheet名]获取第一个Sheet的数据
        var a=wb.SheetNames[0];
        var b=wb.Sheets[a];//内容为方式2
        excelDataArray=XLSX.utils.sheet_to_json(b);//内容为方式1
        callback(excelDataArray)
    };
    if(rABS) {
        reader.readAsArrayBuffer(f);
    } else {
        reader.readAsBinaryString(f);
    }
    function fixdata(data) { //文件流转BinaryString
        var o = "",
            l = 0,
            w = 10240;
        for(; l < data.byteLength / w; ++l) o += String.fromCharCode.apply(null, new Uint8Array(data.slice(l * w, l * w + w)));
        o += String.fromCharCode.apply(null, new Uint8Array(data.slice(l * w)));
        return o;
    }
}